;=========================================================================      
; Project:       ADC_Polling_for NY8B062D version
; =========================================================================
;--------------- File Include ---------------------------------------------
;--------------------------------------------------------------------------
#include		NY8B062D.H						; The Header File for NY8B062D

;--------------- Variable Defination --------------------------------------
;20h~7fh
;--------------------------------------------------------------------------	
rflag			equ	20h
mflag			equ	21h


;--------------------------------------------------------------------------
adcdatal		equ	30h
adcdatah		equ	31h
adcdatat		equ	32h
rcount			equ	33h
AccBuf			equ	34h
StatusBuf		equ	35h	
R_Quarter_VDD_DATA_HB	equ	36h
R_Quarter_VDD_DATA_LB	equ	37h


;--------------- Constant Defination --------------------------------------
;--------------------------------------------------------------------------
		
;--------------- Vector Defination ----------------------------------------
;--------------------------------------------------------------------------
;************ Reset Vector **************************	
		ORG		0x000
		lgoto		V_Main
	
		org         	0x008
        	lgoto       	V_INT
	
	
		ORG		0x010
;--------------- Code Start -----------------------------------------------
V_INT:
		movar       	AccBuf                          ;Store ACC value                  
        	swapr       	AccBuf,1                      
        	movr        	Pr_Status,0                  
        	movar       	StatusBuf                       ;Store STATUS value	
;--------------------------------------------------------------------------        	
PB_INIT:							;PORT CHANGE INTERRUPT
		btrss		Pr_INT_Flag,1
		lgoto		TMR1_INITON
		
		movia		11111101b
		movar		Pr_INT_Flag    
		
		lgoto		TMR1_INITON
;-------------------------------------------------------------------------
TMR1_INITON:							;TMR1
        	btrss		Pr_INT_Flag,3
		lgoto		TMR0_INITON
		
		movia		11110111b
		movar		Pr_INT_Flag    


		lgoto		TMR0_INITON		
		
;---------------------------------------------------------------------------
TMR0_INITON:							;TMR0
		btrss		Pr_INT_Flag,0
		lgoto		exit_init
		
		movia		11111110b
		movar		Pr_INT_Flag   
		
;---------------------------------------------------------------------------        	
exit_init:	  
       	 	movr        	StatusBuf,0
        	movar       	Pr_Status                       ;Restore STATUS value
        	swapr       	AccBuf,0                        ;Restore ACC value	
        	retie                                       	;Return from interrupt and enable interrupt globally        	 
;====================================================================================	
CHECK_ADC:              			
		movia		0x90 | C_ADC_PA0		; Select internal PA0 as ADC input
		movar		Pr_ADC_ADMD					; (SFR "ADMD")
		bsr		Pr_ADC_ADMD,C_Start_Bit		; Start a ADC conversion session

L_eoc_is_0:
		clrwdt		
		btrss		Pr_ADC_ADMD,C_Finish_Bit	; wait for eoc changes state to 1 (ADC convert complete) (SFR "ADMD")
		goto		L_eoc_is_0
		
		
		movr		Pr_ADC_Data,C_SaveToAcc		; SFR "ADD" save to ACC
		movar		R_Quarter_VDD_DATA_HB		; RAM "R_Quarter_VDD_DATA_HB" Store 1/4 VDD ADC data bit 11~4
		movr		Pr_ADC_ADR,C_SaveToAcc		; SFR "ADR" save to ACC
		andia		0x0F						; Only get Bit3~0
		movar		R_Quarter_VDD_DATA_LB		; RAM "R_Quarter_VDD_DATA_LB" bit3~0 Store 1/4 VDD ADC data bit 3~0   		
        
        
		RET
;==========================================================================
;--------------------------------------------------------------------------
V_Main:	
;Initial GPIO	
		movia		00000001B
		iost		Pf_PA_Dir_Ctrl					; Set all PORTA as input pin (SFR "IOSTA")
		movia		00000000B
		iost		Pf_PB_Dir_Ctrl					; Set all PORTB as input pin (SFR "IOSTB")		
       	 	movia   	00000001B
        	movar   	Pr_PA_Data					; PORTA data buffer=0xFF (SFR "PORTA")   
        	movia		00000000B
        	movar   	Pr_PB_Data					; PORTB data buffer=0x3F (SFR "PORTB")          
                        	
		
		        	
		movia		10001000B
		movar		PCON					
		
		movia       	1111111b    					                
       	 	movar       	BPHCON	                       
        	movia       	00000000b                       		
        	movar      	BWUCON     
        	movia		00000000b					
        	movar		AWUCON 
        	movia       	11111111b                       
        	movar       	ABPLCON                         		
        	movia       	11111111b                       
        	iost        	APHCON                          		
;---------------------------------------------------------------------
REGISTER_INIT:


		
;---------------------------------------------------------------------		        	
;Initial ADC 			
	    	movia		C_ADC_En | C_ADC_CH_Dis | C_ADC_PA0  
		movar		Pr_ADC_ADMD					; Enable ADC power, Disable global ADC input channel, Select PA0 pad as ADC input (SFR "ADMD") 	

	;----- ADC high reference voltage source select-----
		movia		C_Vrefh_VDD					; ADC reference high voltage is supplied by internal VDD (Note: ADC clock freq. must be equal or less 2MHz @ VDD=5.0V) 				
		movar		Pr_ADC_Vrefh					; (SFR "ADVREFH") 
	;--------------------------------------------------
	
	;----- ADC clock frequency select----------------------------			
		movia		C_Ckl_Div16					; ADC clock=Fcpu/16, Clear ADIF, disable ADC interrupt			
		movar		Pr_ADC_ADR					; (SFR "ADR") 
	;--------------------------------------------------	
	
	;----- ADC Sampling pulse width select-------------	
		movia		C_Sample_8clk | C_12BIT				; Sample pulse width=8 adc clock, ADC select 12-bit conversion ( Note: ADC clock freq. must be equal or less 2MHz)	
		movar		Pr_ADC_ADCR					; (SFR "ADCR")
	;--------------------------------------------------	
										
		movia		C_PA0_AIN0					;C_PB2_AIN7 | C_PB1_AIN6 | C_PB0_AIN5 | C_PA4_AIN4 | C_PA3_AIN3 | C_PA2_AIN2 | C_PA1_AIN1 | C_PA0_AIN0
		movar		Pr_AIN_Ctrl					; Set AIN0(PA0) to AIN7(PB2) as pure ADC input for reduce power consumption (SFR "PACON")
		movia		C_Sample_8clk | C_12BIT
		movar		Pr_ADC_ADCR					; Set AIN8(PB3) to AIN10(PB5) as pure ADC input for reduce power consumption (SFR "ADCR")
                        	
		bsr		Pr_ADC_ADMD,C_ADC_CH_En_Bit			; Enable global ADC channel	(SFR "ADMD")
;------------------------------------------------------------------------------------
TMR0_INIT:        
		CLRR		TMR0
		MOVIA		10100110B					;1:128(1/32768X128X256=1S)
		T0MD
                                  
;====================================================
TMR1_INIT:               
		clrr		TMRH                                                                 
       	 	movia       	100               
        	sfun        	TMR1 
        	movia       	00000011b                       
        	sfun        	T1CR1
        	movia       	00000000b                       
        	sfun        	T1CR2						;1:2



		movia		00001011b		
		movar		Pr_INT_Ctrl					; Disable all interrupt enable bit (SFR "INTE") 
		clrr		Pr_INT_Flag
		
		
		ENI
;------------------------------------------------------------------------------------		
L_MainLoop:	
        	clrwdt	
     
        	LCALL		CHECK_ADC							; clear watchdog timer

		LGOTO		L_MainLoop
;-----------------------------------------------------------------------------------  

;--------------------------------------------------------------------------------------
		end